#ifndef TFORM_INCLUDED
#define TFORM_INCLUDED

#include <ostream>

#include "TCoord.hh"

//a 4x4 matrix
//this stuff is not debugged...

class TForm
{
public:
  TForm(void);
  ~TForm(void);

  float m[4][4];
};

TForm operator*(const TForm &lhs, const TForm &rhs);

TForm CreateIdentity(void);
TForm CreateScale(float scale);
TForm CreateRevY(void);
TForm CreateRotX(float angRad);
TForm CreateRotY(float angRad);
TForm CreateRotZ(float angRad);
TForm CreateOffset(float xOffset, float yOffset, float zOffset);


TCoord operator*(const TForm &tform, const TCoord coord);

std::ostream& operator<<(std::ostream &out, TForm &rTform);

#endif //TFORM_INCLUDED
